Index: trunk/FACT++/dim/dim/dic.hxx
===================================================================
--- trunk/FACT++/dim/dim/dic.hxx	(revision 14939)
+++ trunk/FACT++/dim/dim/dic.hxx	(revision 15282)
@@ -57,7 +57,7 @@
 		{ subscribe((char *)name, time, &nolink, sizeof(short), 0); };
 	DimInfo(const char *name, char *nolink) 
-		{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, 0); };
+		{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, 0); };
 	DimInfo(const char *name, int time, char *nolink) 
-		{ subscribe((char *)name, time, nolink, strlen(nolink)+1, 0); };
+		{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, 0); };
 	DimInfo(const char *name, void *nolink, int nolinksize) 
 		{ subscribe((char *)name, 0, nolink, nolinksize, 0); };
@@ -86,7 +86,7 @@
 		{ subscribe((char *)name, time, &nolink, sizeof(short), handler); };
 	DimInfo(const char *name, char *nolink, DimInfoHandler *handler) 
-		{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, handler); };
+		{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, handler); };
 	DimInfo(const char *name, int time, char *nolink, DimInfoHandler *handler) 
-		{ subscribe((char *)name, time, nolink, strlen(nolink)+1, handler); };
+		{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, handler); };
 	DimInfo(const char *name, void *nolink, int nolinksize, DimInfoHandler *handler) 
 		{ subscribe((char *)name, 0, nolink, nolinksize, handler); };
@@ -158,7 +158,7 @@
 	{ subscribe((char *)name, time, &nolink, sizeof(short), 0); };
 	DimStampedInfo(const char *name, char *nolink) 
-	{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, 0); };
+	{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, 0); };
 	DimStampedInfo(const char *name, int time, char *nolink) 
-	{ subscribe((char *)name, time, nolink, strlen(nolink)+1, 0); };
+	{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, 0); };
 	DimStampedInfo(const char *name, void *nolink, int nolinksize) 
 	{ subscribe((char *)name, 0, nolink, nolinksize, 0); };
@@ -187,7 +187,7 @@
 	{ subscribe((char *)name, time, &nolink, sizeof(short), handler); };
 		DimStampedInfo(const char *name, char *nolink, DimInfoHandler *handler) 
-	{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, handler); };
+	{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, handler); };
 	DimStampedInfo(const char *name, int time, char *nolink, DimInfoHandler *handler) 
-	{ subscribe((char *)name, time, nolink, strlen(nolink)+1, handler); };
+	{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, handler); };
 	DimStampedInfo(const char *name, void *nolink, int nolinksize, DimInfoHandler *handler) 
 	{ subscribe((char *)name, 0, nolink, nolinksize, handler); };
@@ -230,7 +230,7 @@
 	{ subscribe((char *)name, time, &nolink, sizeof(short), 0); };
 	DimUpdatedInfo(const char *name, char *nolink) 
-	{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, 0); };
+	{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, 0); };
 	DimUpdatedInfo(const char *name, int time, char *nolink) 
-	{ subscribe((char *)name, time, nolink, strlen(nolink)+1, 0); };
+	{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, 0); };
 	DimUpdatedInfo(const char *name, void *nolink, int nolinksize) 
 	{ subscribe((char *)name, 0, nolink, nolinksize, 0); };
@@ -259,7 +259,7 @@
 	{ subscribe((char *)name, time, &nolink, sizeof(short), handler); };
 	DimUpdatedInfo(const char *name, char *nolink, DimInfoHandler *handler) 
-	{ subscribe((char *)name, 0, nolink, strlen(nolink)+1, handler); };
+	{ subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1, handler); };
 	DimUpdatedInfo(const char *name, int time, char *nolink, DimInfoHandler *handler) 
-	{ subscribe((char *)name, time, nolink, strlen(nolink)+1, handler); };
+	{ subscribe((char *)name, time, nolink, (int)strlen(nolink)+1, handler); };
 	DimUpdatedInfo(const char *name, void *nolink, int nolinksize, DimInfoHandler *handler) 
 	{ subscribe((char *)name, 0, nolink, nolinksize, handler); };
@@ -310,5 +310,5 @@
 		subscribe((char *)name, 0, &nolink, sizeof(short)); };
 	DimCurrentInfo(const char *name, char *nolink) { 
-		subscribe((char *)name, 0, nolink, strlen(nolink)+1); };
+		subscribe((char *)name, 0, nolink, (int)strlen(nolink)+1); };
 	DimCurrentInfo(const char *name, void *nolink, int nolinksize) { 
 		subscribe((char *)name, 0, nolink, nolinksize); };
@@ -324,5 +324,5 @@
 		subscribe((char *)name, time, &nolink, sizeof(short)); };
 	DimCurrentInfo(const char *name, int time, char *nolink) { 
-		subscribe((char *)name, time, nolink, strlen(nolink)+1); };
+		subscribe((char *)name, time, nolink, (int)strlen(nolink)+1); };
 	DimCurrentInfo(const char *name, int time, void *nolink, int nolinksize) { 
 		subscribe((char *)name, time, nolink, nolinksize); };
@@ -377,5 +377,5 @@
 		subscribe((char *)name, 0, 0, &nolink, sizeof(short), 0); };
 	DimRpcInfo(const char *name, char *nolink) { 
-		subscribe((char *)name, 0, 0, nolink, strlen(nolink)+1, 0); };
+		subscribe((char *)name, 0, 0, nolink, (int)strlen(nolink)+1, 0); };
 	DimRpcInfo(const char *name, void *nolink, int nolinksize) { 
 		subscribe((char *)name, 0, 0, nolink, nolinksize, 0); };
@@ -392,5 +392,5 @@
 		subscribe((char *)name, 0, 0, &nolink, sizeof(short), time); };
 	DimRpcInfo(const char *name, int time, char *nolink) { 
-		subscribe((char *)name, 0, 0, nolink, strlen(nolink)+1, time); };
+		subscribe((char *)name, 0, 0, nolink, (int)strlen(nolink)+1, time); };
 	DimRpcInfo(const char *name, int time, void *nolink, int nolinksize) { 
 		subscribe((char *)name, 0, 0, nolink, nolinksize, time); };
@@ -417,5 +417,5 @@
 	void setData(longlong &data) { doIt(&data, sizeof(longlong)); } ;
 	void setData(short &data) { doIt(&data, sizeof(short)); } ;
-	void setData(char *data)  { doIt(data, strlen(data)+1); } ;
+	void setData(char *data)  { doIt(data, (int)strlen(data)+1); } ;
 
 private :
Index: trunk/FACT++/dim/dim/dim.h
===================================================================
--- trunk/FACT++/dim/dim/dim.h	(revision 14939)
+++ trunk/FACT++/dim/dim/dim.h	(revision 15282)
@@ -14,5 +14,5 @@
 #include "dim_common.h"
 
-#define DIM_VERSION_NUMBER 2005
+#define DIM_VERSION_NUMBER 2007
 
 
Index: trunk/FACT++/dim/dim/dim_common.h
===================================================================
--- trunk/FACT++/dim/dim/dim_common.h	(revision 14939)
+++ trunk/FACT++/dim/dim/dim_common.h	(revision 15282)
@@ -124,4 +124,15 @@
 #include <unistd.h>
 
+extern int DIM_Threads_OFF;
+
+#define DISABLE_SIG     sigset_t set, oset; if (DIM_Threads_OFF) {\
+                                                sigemptyset(&set);\
+												sigaddset(&set,SIGIO);\
+												sigaddset(&set,SIGALRM);\
+												sigprocmask(SIG_BLOCK,&set,&oset);}
+#define ENABLE_SIG       if (DIM_Threads_OFF) {\
+                                                sigprocmask(SIG_SETMASK,&oset,0);}
+
+/*
 #define DISABLE_SIG     sigset_t set, oset; sigemptyset(&set);\
 						sigaddset(&set,SIGIO);\
@@ -129,8 +140,10 @@
 						sigprocmask(SIG_BLOCK,&set,&oset);
 #define ENABLE_SIG      sigprocmask(SIG_SETMASK,&oset,0);
-
-#ifdef VxWorks
+*/
+
 #define DISABLE_AST     DISABLE_SIG DIM_LOCK
 #define ENABLE_AST      DIM_UNLOCK ENABLE_SIG
+
+#ifdef VxWorks
 #define DIM_LOCK taskLock();
 #define DIM_UNLOCK taskUnlock();
@@ -145,6 +158,4 @@
 _DIM_PROTOE( void dim_signal_cond,	() );
 
-#define DISABLE_AST     DIM_LOCK
-#define ENABLE_AST      DIM_UNLOCK
 #define DIM_LOCK 	dim_lock();
 #define DIM_UNLOCK	dim_unlock();
@@ -152,6 +163,4 @@
 #else
 #include <time.h>
-#define DISABLE_AST     DISABLE_SIG DIM_LOCK
-#define ENABLE_AST      DIM_UNLOCK ENABLE_SIG
 #define DIM_LOCK
 #define DIM_UNLOCK
Index: trunk/FACT++/dim/src/conn_handler.c
===================================================================
--- trunk/FACT++/dim/src/conn_handler.c	(revision 14939)
+++ trunk/FACT++/dim/src/conn_handler.c	(revision 15282)
@@ -57,17 +57,17 @@
 	case SRC_DIC :
 		Dic_conns = (DIC_CONNECTION *)
-				calloc( Curr_N_Conns, sizeof(DIC_CONNECTION) );
+				calloc( (size_t)Curr_N_Conns, sizeof(DIC_CONNECTION) );
 		My_type = type;
 		break;
 	case SRC_DNS :
 		Dns_conns = (DNS_CONNECTION *)
-				calloc( Curr_N_Conns, sizeof(DNS_CONNECTION) );
+				calloc( (size_t)Curr_N_Conns, sizeof(DNS_CONNECTION) );
 		My_type = type;
 		break;
 	case SRC_DNA :
 		Dna_conns = (DNA_CONNECTION *)
-				calloc( Curr_N_Conns, sizeof(DNA_CONNECTION) );
+				calloc( (size_t)Curr_N_Conns, sizeof(DNA_CONNECTION) );
 		Net_conns = (NET_CONNECTION *)
-				calloc( Curr_N_Conns, sizeof(NET_CONNECTION) );
+				calloc( (size_t)Curr_N_Conns, sizeof(NET_CONNECTION) );
 		break;
 	default:
@@ -128,6 +128,6 @@
 	register char *new_ptr;
 
-	new_ptr = realloc( conn_ptr, conn_size * n_conns );
-	memset( new_ptr + conn_size * Curr_N_Conns, 0, conn_size * CONN_BLOCK );
+	new_ptr = realloc( conn_ptr, (size_t)(conn_size * n_conns) );
+	memset( new_ptr + conn_size * Curr_N_Conns, 0, (size_t)(conn_size * CONN_BLOCK) );
 	return(new_ptr);
 }
@@ -137,5 +137,5 @@
 
 	Curr_N_Ids = ID_BLOCK;
-	Id_arr = (void *) calloc( Curr_N_Ids, sizeof(ID_ITEM));
+	Id_arr = (void *) calloc( (size_t)Curr_N_Ids, sizeof(ID_ITEM));
 }
 
@@ -145,6 +145,6 @@
 	register char *new_ptr;
 
-	new_ptr = realloc( id_ptr, id_size * n_ids );
-	memset( new_ptr + id_size * Curr_N_Ids, 0, id_size * ID_BLOCK );
+	new_ptr = realloc( id_ptr, (size_t)(id_size * n_ids) );
+	memset( new_ptr + id_size * Curr_N_Ids, 0, (size_t)(id_size * ID_BLOCK) );
 	return(new_ptr);
 }
Index: trunk/FACT++/dim/src/copy_swap.c
===================================================================
--- trunk/FACT++/dim/src/copy_swap.c	(revision 14939)
+++ trunk/FACT++/dim/src/copy_swap.c	(revision 15282)
@@ -176,5 +176,5 @@
 	if(!format_data->par_bytes) {
 		if(buff_in != buff_out)
-			memcpy( buff_out, buff_in, size );
+			memcpy( buff_out, buff_in, (size_t)size );
 		return(size);
 	}
@@ -196,5 +196,5 @@
 					size - curr_size, SIZEOF_CHAR);
 
-				memcpy( buff_out, buff_in, num);
+				memcpy( buff_out, buff_in, (size_t)num);
 				inc_pter( buff_in, num);
 				inc_pter( buff_out, num);
@@ -213,5 +213,5 @@
 					}
 				}
-				memcpy( buff_out, buff_in, num);
+				memcpy( buff_out, buff_in, (size_t)num);
 				inc_pter( buff_in, num);
 				inc_pter( buff_out, num);
@@ -230,5 +230,5 @@
 					}
 				}
-				memcpy( buff_out, buff_in, num);
+				memcpy( buff_out, buff_in, (size_t)num);
 				inc_pter( buff_in, num);
 				inc_pter( buff_out, num);
@@ -251,5 +251,5 @@
 					}
 				}
-				memcpy( buff_out, buff_in, num);
+				memcpy( buff_out, buff_in, (size_t)num);
 				inc_pter( buff_in, num);
 				inc_pter( buff_out, num);
@@ -276,5 +276,5 @@
 	if(!format_data->par_bytes) {
 		if(buff_in != buff_out)
-			memcpy( buff_out, buff_in, size );
+			memcpy( buff_out, buff_in, (size_t)size );
 		return(size);
 	}
@@ -322,5 +322,5 @@
 
 				if(buff_in != buff_out)
-					memcpy( buff_out, buff_in, num);
+					memcpy( buff_out, buff_in, (size_t)num);
 				inc_pter( buff_in, num);
 				inc_pter( buff_out, num);
Index: trunk/FACT++/dim/src/dic.c
===================================================================
--- trunk/FACT++/dim/src/dic.c	(revision 14939)
+++ trunk/FACT++/dim/src/dic.c	(revision 15282)
@@ -224,5 +224,5 @@
 					{
 						servp->pending = WAITING_DNS_UP;
-						dic_release_service( servp->serv_id );
+						dic_release_service( (unsigned)servp->serv_id );
 					}
 					servp = auxp;
@@ -237,5 +237,5 @@
 			break;
 		service_id = vtohl(packet->service_id);
-		if(service_id & 0x80000000)  /* Service removed by server */
+		if((unsigned)service_id & 0x80000000)  /* Service removed by server */
 		{
 			service_id &= 0x7fffffff;
@@ -288,5 +288,5 @@
 							{
 								servp->pending = WAITING_DNS_UP;
-								dic_release_service( servp->serv_id );
+								dic_release_service( (unsigned)servp->serv_id );
 							}
 							servp = auxp;
@@ -337,5 +337,5 @@
 					{
 						servp->pending = WAITING_DNS_UP;
-						dic_release_service( servp->serv_id );
+						dic_release_service( (unsigned)servp->serv_id );
 					}
 					else
@@ -390,5 +390,5 @@
 	{
 		for(formatp = format_data_cp; formatp->par_bytes; formatp++)
-			formatp->flags &= 0xFFF0;    /* NOSWAP */
+			formatp->flags &= (short)0xFFF0;    /* NOSWAP */
 	}
 	if( servp->stamped)
@@ -397,5 +397,5 @@
 		header_size = DIS_STAMPED_HEADER;
 		servp->time_stamp[0] = vtohl(((DIS_STAMPED_PACKET *)packet)->time_stamp[0]);
-		if((servp->time_stamp[0] & 0xFFFF0000) == 0xc0de0000)
+		if(((unsigned)servp->time_stamp[0] & 0xFFFF0000) == 0xc0de0000)
 		{
 /*
@@ -442,5 +442,5 @@
 			if(!buffer_size)
 			{
-				buffer = (int *)malloc(add_size);
+				buffer = (int *)malloc((size_t)add_size);
 				buffer_size = add_size;
 			} 
@@ -450,5 +450,5 @@
 				{
 					free(buffer);
-					buffer = (int *)malloc(add_size);
+					buffer = (int *)malloc((size_t)add_size);
 					buffer_size = add_size;
 				}
@@ -550,5 +550,5 @@
 			(servp->user_routine)( &servp->tag, &size );
 		}
-		dic_release_service( servp->serv_id );
+		dic_release_service( (unsigned)servp->serv_id );
 		Curr_conn_id = 0;
 		return;
@@ -567,5 +567,5 @@
 			if( size > servp->serv_size ) 
 				size = servp->serv_size; 
-			memcpy(servp->serv_address, servp->fill_address, size);
+			memcpy(servp->serv_address, servp->fill_address, (size_t)size);
 			if( servp->user_routine )
 				(servp->user_routine)( &servp->tag, servp->serv_address, &size);
@@ -579,5 +579,5 @@
 	if( once_only )
 	{
-		dic_release_service( servp->serv_id );
+		dic_release_service( (unsigned)servp->serv_id );
 	}
 	Curr_conn_id = 0;
@@ -760,6 +760,6 @@
 				if(serv_size > 0)
 				{
-					fillp = (int *)malloc(serv_size);
-					memcpy( (char *)fillp, (char *)serv_address, serv_size );
+					fillp = (int *)malloc((size_t)serv_size);
+					memcpy( (char *)fillp, (char *)serv_address, (size_t)serv_size );
 				}
 				servp->fill_address = fillp;
@@ -807,5 +807,5 @@
 	newp = (DIC_SERVICE *) malloc(sizeof(DIC_SERVICE));
 	newp->pending = 0;
-	strncpy( newp->serv_name, name, MAX_NAME );
+	strncpy( newp->serv_name, name, (size_t)MAX_NAME );
 	newp->type = type;
 	newp->timeout = timeout;
@@ -817,6 +817,6 @@
 	if(fill_size > 0)
 	{
-		fillp = (int *)malloc(fill_size);
-		memcpy( (char *) fillp, (char *) fill_addr, fill_size );
+		fillp = (int *)malloc((size_t)fill_size);
+		memcpy( (char *) fillp, (char *) fill_addr, (size_t)fill_size );
 	}
 	newp->fill_address = fillp;
@@ -888,6 +888,6 @@
 	if(fill_size > 0)
 	{
-		fillp = (int *)malloc(fill_size);
-		memcpy( (char *) fillp, (char *) fill_addr, fill_size );
+		fillp = (int *)malloc((size_t)fill_size);
+		memcpy( (char *) fillp, (char *) fill_addr, (size_t)fill_size );
 	}
 	servp->fill_address = fillp;
@@ -993,5 +993,5 @@
 	{
 		*secs = servp->time_stamp[1];
-		if((servp->time_stamp[0] & 0xFFFF0000) == 0xc0de0000)
+		if(((unsigned)servp->time_stamp[0] & 0xFFFF0000) == 0xc0de0000)
 			*milisecs = servp->time_stamp[0] & 0x0000FFFF;
 		else
@@ -1022,5 +1022,5 @@
 	DISABLE_AST
 	if( !packet_size ) {
-		dic_packet = (DIC_PACKET *)malloc(DIC_HEADER);
+		dic_packet = (DIC_PACKET *)malloc((size_t)DIC_HEADER);
 		packet_size = DIC_HEADER;
 	}
@@ -1046,7 +1046,7 @@
 	case NOT_PENDING :
 		conn_id = servp->conn_id;
-		strncpy(dic_packet->service_name, servp->serv_name, MAX_NAME); 
+		strncpy(dic_packet->service_name, servp->serv_name, (size_t)MAX_NAME); 
 		dic_packet->type = htovl(DIM_DELETE);
-		dic_packet->service_id = htovl(service_id);
+		dic_packet->service_id = (int)htovl(service_id);
 		dic_packet->size = htovl(DIC_HEADER);
 		dna_write_nowait( conn_id, dic_packet, DIC_HEADER );
@@ -1064,5 +1064,5 @@
 			serv_reqp = &dic_dns_p->service;
 			strcpy( serv_reqp->service_name, servp->serv_name );
-			serv_reqp->service_id = htovl(servp->serv_id | 0x80000000);
+			serv_reqp->service_id = (int)htovl((unsigned)servp->serv_id | 0x80000000);
 			dna_write( Dns_dic_conn_id, dic_dns_p,
 				  sizeof(DIC_DNS_PACKET) );
@@ -1193,5 +1193,5 @@
 		return((DIC_SERVICE *)0);
 	if( (servp = (DIC_SERVICE *) dll_search( (DLL *) Cmnd_head, serv_name,
-					    strlen(serv_name)+1)) )
+					    (int)strlen(serv_name)+1)) )
 		return(servp);
 	return((DIC_SERVICE *)0);
@@ -1205,5 +1205,5 @@
 		return((DIC_SERVICE *)0);
 	if( (servp = (DIC_SERVICE *) dll_search( (DLL *) Service_pend_head, serv_name,
-					    strlen(serv_name)+1)) )
+					    (int)strlen(serv_name)+1)) )
 		return(servp);
 	return((DIC_SERVICE *)0);
@@ -1372,5 +1372,5 @@
 	strcpy(node_info,node_name);
 	for(i = 0; i < 4; i ++)
-		node_info[strlen(node_name)+i+1] = packet->node_addr[i];
+		node_info[(int)strlen(node_name)+i+1] = packet->node_addr[i];
 	port = vtohl(packet->port); 
 	pid = vtohl(packet->pid); 
@@ -1386,5 +1386,5 @@
 			serv_reqp = &dic_dns_p->service;
 			strcpy( serv_reqp->service_name, servp->serv_name );
-			serv_reqp->service_id = htovl(servp->serv_id | 0x80000000);
+			serv_reqp->service_id = (int)htovl((unsigned)servp->serv_id | 0x80000000);
 			dna_write( Dns_dic_conn_id, dic_dns_p,
 				  sizeof(DIC_DNS_PACKET) );
@@ -1405,5 +1405,5 @@
 				serv_reqp = &dic_dns_p->service;
 				strcpy( serv_reqp->service_name, servp->serv_name );
-				serv_reqp->service_id = htovl(servp->serv_id | 0x80000000);
+				serv_reqp->service_id = (int)htovl((unsigned)servp->serv_id | 0x80000000);
 				dna_write( Dns_dic_conn_id, dic_dns_p,
 					sizeof(DIC_DNS_PACKET) );
@@ -1456,7 +1456,7 @@
 			dic_connp = &Dic_conns[conn_id];
 			strncpy( dic_connp->node_name, node_name,
-				 MAX_NODE_NAME); 
+				 (size_t)MAX_NODE_NAME); 
 			strncpy( dic_connp->task_name, task_name,
-				 MAX_TASK_NAME);
+				 (size_t)MAX_TASK_NAME);
 			dic_connp->port = port;
 			dic_connp->pid = pid;
@@ -1508,6 +1508,6 @@
 			bad_connp->n_retries++;
 			bad_connp->retrying = 0;
-			strncpy( bad_connp->conn.node_name, node_name, MAX_NODE_NAME); 
-			strncpy( bad_connp->conn.task_name, task_name, MAX_TASK_NAME);
+			strncpy( bad_connp->conn.node_name, node_name, (size_t)MAX_NODE_NAME); 
+			strncpy( bad_connp->conn.task_name, task_name, (size_t)MAX_TASK_NAME);
 			bad_connp->conn.port = port;
 			tmout = BAD_CONN_TIMEOUT * (bad_connp->n_retries - 1);
@@ -1804,5 +1804,5 @@
 		{
 			servp->pending = WAITING_DNS_UP;
-			dic_release_service( servp->serv_id );
+			dic_release_service( (unsigned)servp->serv_id );
 		}
 		else
@@ -1818,5 +1818,5 @@
 				{
 					servp->pending = WAITING_DNS_UP;
-					dic_release_service( servp->serv_id );
+					dic_release_service( (unsigned)servp->serv_id );
 				}
 			}
@@ -1859,5 +1859,5 @@
 			{
 				servp->pending = WAITING_DNS_UP;
-				dic_release_service( servp->serv_id );
+				dic_release_service( (unsigned)servp->serv_id );
 			}
 			else
@@ -1882,9 +1882,9 @@
 
 	if( !serv_packet_size ) {
-		dic_packet = (DIC_PACKET *)malloc(DIC_HEADER);
+		dic_packet = (DIC_PACKET *)malloc((size_t)DIC_HEADER);
 		serv_packet_size = DIC_HEADER;
 	}
 
-	strncpy( dic_packet->service_name, servp->serv_name, MAX_NAME ); 
+	strncpy( dic_packet->service_name, servp->serv_name, (size_t)MAX_NAME ); 
 	type = servp->type;
 	if(servp->stamped)
@@ -1954,5 +1954,5 @@
 
 	if( !cmnd_packet_size ) {
-		dic_packet = (DIC_PACKET *)malloc(DIC_HEADER + size);
+		dic_packet = (DIC_PACKET *)malloc((size_t)(DIC_HEADER + size));
 		cmnd_packet_size = DIC_HEADER + size;
 	}
@@ -1961,10 +1961,10 @@
 		if( DIC_HEADER + size > cmnd_packet_size ) {
 			free( dic_packet );
-			dic_packet = (DIC_PACKET *)malloc(DIC_HEADER + size);
+			dic_packet = (DIC_PACKET *)malloc((size_t)(DIC_HEADER + size));
 			cmnd_packet_size = DIC_HEADER + size;
 		}
 	}
 
-	strncpy(dic_packet->service_name, servp->serv_name, MAX_NAME); 
+	strncpy(dic_packet->service_name, servp->serv_name, (size_t)MAX_NAME); 
 	dic_packet->type = htovl(COMMAND);
 	dic_packet->timeout = htovl(0);
@@ -2000,5 +2000,5 @@
 	{
 		servp->pending = WAITING_DNS_UP;
-		dic_release_service( servp->serv_id );
+		dic_release_service( (unsigned)servp->serv_id );
 	}
 */
@@ -2008,5 +2008,5 @@
 	{
 		servp->pending = WAITING_DNS_UP;
-		dic_release_service( servp->serv_id );
+		dic_release_service( (unsigned)servp->serv_id );
 	}
 	else
@@ -2052,5 +2052,5 @@
 	get_proc_name(name);
 	strcat(name,"@");
-	get_node_name(&name[strlen(name)]);
+	get_node_name(&name[(int)strlen(name)]);
 	return(1);
 }
@@ -2077,5 +2077,5 @@
 			  {
 			    auxp = servp->prev;
-			    dic_release_service( servp->serv_id );
+			    dic_release_service( (unsigned)servp->serv_id );
 			    servp = auxp;
 			    if(!dic_connp->service_head)
@@ -2157,5 +2157,5 @@
 				{
 					servp->pending = WAITING_DNS_UP;
-					dic_release_service( servp->serv_id );
+					dic_release_service( (unsigned)servp->serv_id );
 				}
 				servp = auxp;
@@ -2249,5 +2249,5 @@
 		if(!curr_allocated_size)
 		{
-			service_info_buffer = (char *)malloc(max_size);
+			service_info_buffer = (char *)malloc((size_t)max_size);
 			curr_allocated_size = max_size;
 		}
@@ -2255,5 +2255,5 @@
 		{
 			free(service_info_buffer);
-			service_info_buffer = (char *)malloc(max_size);
+			service_info_buffer = (char *)malloc((size_t)max_size);
 			curr_allocated_size = max_size;
 		}
@@ -2268,5 +2268,5 @@
 			strcat(buff_ptr, servp->serv_name);
 			strcat(buff_ptr, "\n");
-			buff_ptr += strlen(buff_ptr);
+			buff_ptr += (int)strlen(buff_ptr);
 		}
 	}
Index: trunk/FACT++/dim/src/diccpp.cxx
===================================================================
--- trunk/FACT++/dim/src/diccpp.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/diccpp.cxx	(revision 15282)
@@ -33,5 +33,5 @@
 				t->itsDataSize = *size;
 			}
-			memcpy(t->itsData, buf, *size);
+			memcpy(t->itsData, buf, (size_t)*size);
 		}
 		else if (*size == 0)
@@ -83,5 +83,5 @@
 			itsDataSize = itsSize;
 		}
-		memcpy(itsData, data, itsSize);
+		memcpy(itsData, data, (size_t)itsSize);
 	}
 }
@@ -125,15 +125,15 @@
 	if(itsFormat)
 	{
-		len = strlen(itsFormat)+1;
+		len = (int)strlen(itsFormat)+1;
 		if(len > 1)
 			return itsFormat;
 	}
 	def = dic_get_format(itsId);
-	new_len = strlen(def)+1;
+	new_len = (int)strlen(def)+1;
 	if(new_len > len)
 	{
 		if(itsFormat)
 			delete[] itsFormat;
-		itsFormat = new char[strlen(def)+1];
+		itsFormat = new char[(int)strlen(def)+1];
 	}
 	strcpy(itsFormat, def);
@@ -166,5 +166,5 @@
 		return;
 	}
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy(itsName,name);
 	itsNolinkBuf = nolink;
@@ -174,5 +174,5 @@
 		itsNolinkBuf = new char[nolinksize];
 		itsNolinkSize = nolinksize;
-		memcpy(itsNolinkBuf, nolink, nolinksize);
+		memcpy(itsNolinkBuf, nolink, (size_t)nolinksize);
 	}
 	if(!time)
@@ -253,5 +253,5 @@
 		return;
 	}
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy(itsName,name);
 	itsNolinkBuf = nolink;
@@ -261,5 +261,5 @@
 		itsNolinkBuf = new char[nolinksize];
 		itsNolinkSize = nolinksize;
-		memcpy(itsNolinkBuf, nolink, nolinksize);
+		memcpy(itsNolinkBuf, nolink, (size_t)nolinksize);
 	}
 	if(!time)
@@ -313,5 +313,5 @@
 		return;
 	}
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy(itsName,name);
 	itsNolinkBuf = nolink;
@@ -321,5 +321,5 @@
 		itsNolinkBuf = new char[nolinksize];
 		itsNolinkSize = nolinksize;
-		memcpy(itsNolinkBuf, nolink, nolinksize);
+		memcpy(itsNolinkBuf, nolink, (size_t)nolinksize);
 	}
 	if(!time)
@@ -363,5 +363,5 @@
 			t->itsDataSize = *size;
 		}
-		memcpy(t->itsData, buf, *size);
+		memcpy(t->itsData, buf, (size_t)*size);
 	}
 	else if (*size == 0)
@@ -404,5 +404,5 @@
 		return;
 	}
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy(itsName,name);
 	itsNolinkBuf = nolink;
@@ -412,5 +412,5 @@
 		itsNolinkBuf = new char[nolinksize];
 		itsNolinkSize = nolinksize;
-		memcpy(itsNolinkBuf, nolink, nolinksize);
+		memcpy(itsNolinkBuf, nolink, (size_t)nolinksize);
 	}
 	if(!time)
@@ -570,5 +570,5 @@
 		{
 			if(size > 0)
-				memcpy(t->itsData, buf, size);
+				memcpy(t->itsData, buf, (size_t)size);
 			else
 				t->itsData = buf;
@@ -633,5 +633,5 @@
 		{
 			if(size > 0)
-				memcpy(itsData, buf, size);
+				memcpy(itsData, buf, (size_t)size);
 			else
 				itsData = buf;
@@ -676,5 +676,5 @@
 			itsDataSize = itsSize;
 		}
-		memcpy(itsData, data, itsSize);
+		memcpy(itsData, data, (size_t)itsSize);
 	}
 }
@@ -688,5 +688,5 @@
 	itsInit = 0;
 	itsWaiting = 0;
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy(itsName,name);
 	itsHandler = this;
@@ -701,10 +701,10 @@
 		itsNolinkBuf = new char[nolinksize];
 		itsNolinkSize = nolinksize;
-		memcpy(itsNolinkBuf, nolink, nolinksize);
-	}
-	itsNameOut = new char[strlen(name)+1+10];
+		memcpy(itsNolinkBuf, nolink, (size_t)nolinksize);
+	}
+	itsNameOut = new char[(int)strlen(name)+1+10];
 	strcpy(itsNameOut,name);
 	strcat(itsNameOut,(char *)"/RpcIn");
-	itsNameIn = new char[strlen(name)+1+10];
+	itsNameIn = new char[(int)strlen(name)+1+10];
 	strcpy(itsNameIn,name);
 	strcat(itsNameIn,(char *)"/RpcOut");
@@ -752,5 +752,5 @@
 			itsDataOutSize = size;
 		}
-		memcpy(itsDataOut, data, size);
+		memcpy(itsDataOut, data, (size_t)size);
 	}
 	else
@@ -883,5 +883,5 @@
 	DimCurrentInfo srv((char *)"DIS_DNS/SERVER_LIST", timeout, (char *)"\0");
 	str = srv.getString();
-	size = strlen(str)+1;
+	size = (int)strlen(str)+1;
 	totsize = srv.getSize();
 
@@ -894,5 +894,5 @@
 	if(totsize > size)
 	{
-		pid_str = str + strlen(str) + 1;
+		pid_str = str + (int)strlen(str) + 1;
 		if(itsData[4])
 			delete itsData[4];
@@ -910,5 +910,5 @@
 {
 	char *str;
-	char *name = new char[strlen(serverName) + 20];
+	char *name = new char[(int)strlen(serverName) + 20];
 	strcpy(name,(char *)serverName);
 	strcat(name,(char *)"/SERVICE_LIST");
@@ -933,5 +933,5 @@
 {
 	char *str;
-	char *name = new char[strlen(serverName) + 20];
+	char *name = new char[(int)strlen(serverName) + 20];
 	strcpy(name,(char *)serverName);
 	strcat(name,(char *)"/CLIENT_LIST");
@@ -1129,5 +1129,5 @@
 { 
 	DimCmnd a;
-	return a.send((char *)name, (char *)data, strlen(data)+1);
+	return a.send((char *)name, (char *)data, (int)strlen(data)+1);
 }
 
@@ -1171,5 +1171,5 @@
 {
 	DimCmnd a;
-	a.sendNB((char *)name, data, strlen(data)+1);
+	a.sendNB((char *)name, data, (int)strlen(data)+1);
 }
 
@@ -1184,5 +1184,5 @@
 	DimCmnd a;
 	int ret, tag = 1;
-	char *name = new char[strlen(srvName) + 20];
+	char *name = new char[(int)strlen(srvName) + 20];
 	strcpy(name,(char *)srvName);
 	strcat(name,"/SET_EXIT_HANDLER");
@@ -1196,5 +1196,5 @@
 	DimCmnd a;
 	int ret, tag = 1;
-	char *name = new char[strlen(srvName) + 20];
+	char *name = new char[(int)strlen(srvName) + 20];
 	strcpy(name,(char *)srvName);
 	strcat(name,"/EXIT");
